<template>
  <div class="flex justify-between mt-3">
    <div class="flex flex-col mt-[3vw] gap-[2vw] vertical-menu">
      <div
        v-for="(tab, index) in Object.entries(tabsForDisplay).filter(
          (item) => item[1].Games.length !== 0
        )"
        :id="ID.TAB_TYPE_MOBILE_RIGHT_SIDE_BAR[tab[1].DisplayName]"
        :key="index"
        :class="`flex flex-col items-center tab justify-between rounded-[3vw] p-[1.5vw] ${
          tab[1].IsActive ? 'active' : ''
        }`"
        @click="onTabClick(tab[0])"
      >
        <div :id="tab[1].Id" class="vertical-tab-icon pointer-events-none"></div>
        <span class="text-[2.5vw] text-center pointer-events-none">{{
          $t(tab[1].DisplayName)
        }}</span>
      </div>
      <div
        v-if="isAppDownloadEnabled"
        :class="[
          'flex flex-col items-center tab justify-between rounded-[3vw] p-[1.5vw]',
          { active: appDownloadSelected },
        ]"
        @click="onAppDownload()"
      >
        <div id="appIcon" class="vertical-tab-icon"></div>
        <span class="text-[2.5vw] text-center">{{ $t("download") }}</span>
      </div>
    </div>
    <div
      style="padding-bottom: 150px"
      class="pl-[3.735vw] overflow-y-auto relative w-full h-[65vh] scroll-smooth block items-center pr-3"
    >
      <div v-for="(tab, index) in Object.entries(tabsForDisplay)" :key="index">
        <div :class="`games-tab ${tab[1].IsActive ? 'fadeInUp' : 'hidden'}`">
          <!-- {{ tab[1].Games }} -->
          <div
            v-for="(game, no) in tab[1].Games"
            :key="no"
            class="mt-[3vw] mx-auto w-full tab-card h-fit tab-shadow overflow-hidden rounded-[3vw] relative"
            :class="{ 'grayscale-[1] pointer-events-none': game.IsMaintain }"
          >
            <div v-if="game.TabType !== 'Cock Fight'">
                <home-tab-item
                  :is-maintain="game.IsMaintain"
                  :is-hot="game.IsGameType ? false : game.IsHotGameProvider"
                  :is-new="game.IsGameType ? false : game.IsNewGameProvider"
                  :background-image="game.GameIconUrlForDisplay"
                  :name1= "getTheRightGameName({ isGameTab: tab[0] === 'game', game })"
                  :name2="
                    getTheRightGameName({ isGameTab: tab[0] === 'game', game })
                  "
                  @click="handleItemClick({ isGameTab: tab[0] === 'game', game })"
                />
            </div>
            <div v-if="game.TabType === 'Cock Fight' && game.GameProviderId !== -1">
              <home-tab-item
                :is-maintain="game.IsMaintain"
                :is-hot="game.IsGameType ? false : game.IsHotGameProvider"
                :is-new="game.IsGameType ? false : game.IsNewGameProvider"
                :background-image="game.GameIconUrlForDisplay"
                :name1="getTheRightGameName({ isGameTab: tab[0] === 'game', game })"
                :name2="
                  getTheRightGameName({ isGameTab: tab[0] === 'game', game })
                "
                @click="handleItemClick({ isGameTab: tab[0] === 'game', game })"
              />
            </div>
          </div>
        </div>
      </div>
      <template v-if="isAppDownloadEnabled">
        <a
          v-if="appDownloadURL === ''"
          :href="appUrl"
          download
          :class="`games-tab ${appDownloadSelected ? 'fadeInUp' : 'hidden'}`"
        >
          <div
            class="mt-[3vw] mx-auto w-full tab-card h-fit tab-shadow overflow-hidden rounded-[3vw] relative"
          >
            <home-tab-item
              :app-download="appDownload.ImagePath"
              :background-image="appBackground"
              :name1="$t('app_download')"
              :name2="$t('app_download')"
            />
          </div>
        </a>
        <a
          v-else
          :href="
            appDownloadURL.includes('://')
              ? appDownloadURL
              : `//${appDownloadURL}`
          "
          target="_blank"
          :class="`games-tab ${appDownloadSelected ? 'fadeInUp' : 'hidden'}`"
        >
          <div
            class="mt-[3vw] mx-auto w-full tab-card h-fit tab-shadow overflow-hidden rounded-[3vw] relative"
          >
            <home-tab-item
              :app-download="appDownload.ImagePath"
              :background-image="appBackground"
              :name1="$t('app_download')"
              :name2="$t('app_download')"
            />
          </div>
        </a>
      </template>
    </div>
  </div>
</template>
<script lang="ts">
import { computed, defineComponent, PropType, ref } from "vue";
import _ from "lodash";
import { useRouter } from "vue-router";
import HomeTabItem from "./HomeTabItem.client.vue";
import { store } from "@/store";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { IGameBsi, GameBsiForLFM1 } from "@/models/bsiGameList";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import {
  useHeaderComponent,
  handleGameEntryOpenWindow,
} from "@/composables/useTheme";
import { gameStore } from "~~/store/game";

interface ITab {
  Id: string;
  IsActive: boolean;
  Games: Array<GameBsiForLFM1>;
  TabType: string;
  DisplayName: string;
  IsCheckCategoryAndProvider: boolean;
  Order: number;
}
interface ITabDetail {
  key: string;
  name: string;
  tabType: string;
  isCheckCategoryAndProvider: boolean;
  order: number;
}

const presetCondition: Record<string, ITabDetail> = {
  sport: {
    key: "index_blog_2",
    name: "sport",
    tabType: "Sports",
    isCheckCategoryAndProvider: false,
    order: 1,
  },
  vSport: {
    key: "index_blog_3",
    name: "virtual",
    tabType: "Virtual Sports",
    isCheckCategoryAndProvider: false,
    order: 2,
  },
  casino: {
    key: "index_blog_4",
    name: "casino",
    tabType: "Live Casino",
    isCheckCategoryAndProvider: false,
    order: 3,
  },
  game: {
    key: "index_blog_5",
    name: "game",
    tabType: "Games",
    isCheckCategoryAndProvider: true,
    order: 4,
  },
  cockFighting: {
    key: "index_blog_6",
    name: "cock",
    tabType: "Cock Fight",
    isCheckCategoryAndProvider: false,
    order: 5,
  },
  poker: {
    key: "index_blog_7",
    name: "poker",
    tabType: "Poker",
    isCheckCategoryAndProvider: false,
    order: 6,
  },
  lottery: {
    key: "index_blog_8",
    name: "lottery",
    tabType: "Lottery",
    isCheckCategoryAndProvider: false,
    order: 7,
  },
};

const renderTabs = (themeProperties: Array<IThemePropertiesFromApi>) => {
  let result: Record<string, ITab> = {};
  Object.entries(presetCondition).forEach(([key, value]) => {
    const themeProperty = themePropertyHelper.getSingleThemeProperty(
      themeProperties,
      value.key
    );
    if (themeProperty) {
      if (!themeProperty.IsHidden) {
        result[key] = {
          Id: `${key}Icon`,
          IsActive: false,
          Games: [],
          DisplayName: value.name,
          TabType: value.tabType,
          IsCheckCategoryAndProvider: value.isCheckCategoryAndProvider,
          Order: themeProperty.ResourceKey
            ? parseInt(themeProperty.ResourceKey, 10)
            : 9,
        };
      }
    }
  });
  result = Object.entries(result)
    .sort((a, b) => a[1].Order - b[1].Order)
    .reduce((obj, [key, value], idx) => {
      if (idx === 0) {
        value.IsActive = true;
      }
      return { ...obj, [key]: value };
    }, {});
  return result;
};
const addGameToTabs = (
  tabs: Record<string, ITab>,
  games: Array<IGameBsi>
): Record<string, ITab> => {
  const result = tabs;
  const orderByGameIDMobile = [61, 1 , 64, 65, 59];
  Object.entries(result).forEach(([key, value]) => {
    let tabGames: Array<GameBsiForLFM1> = [];
    if (value.IsCheckCategoryAndProvider) {
      const temGameTabs = games.filter(
        (game) =>
          game.TabType.trim() === value.TabType &&
          game.ForMobile &&
          game.GameType.toLowerCase() !== "none"
      );
      const categoriesGame = _.uniqBy(temGameTabs, "GameType").map(
        (game) => new GameBsiForLFM1(game, false, true)
        );
      const providerGames = _.orderBy(
        _.orderBy(
          _.uniqBy(temGameTabs, "GameProviderName").map(
            (game) => new GameBsiForLFM1(game, true)
          ),
          "GameProviderName"
        ),
        "DisplayOrder"
      );
      tabGames = categoriesGame.concat(providerGames);
    } else {
      tabGames = games
        .filter(
          (game) => game.TabType.trim() === value.TabType && game.ForMobile
        )
        .map((game) => new GameBsiForLFM1(game));
    }
    result[key].Games = tabGames;
  });
  result['sport'].Games = _.sortBy(result['sport'].Games, (game) => {
    const index = orderByGameIDMobile.indexOf(game.GameId);
    return index === -1 ? Infinity : index;
  });
  // const favorite = new GameBsiForLFM1(games[0]);
  // favorite.GameType = 'Favorite';
  // favorite.EnglishGameName = 'Favorite';
  // favorite.CategoryName = 'Favorite';
  // if (result['game'].Games.some((item) => item.GameType !== 'Favorite')) result['game'].Games.unshift(favorite);
  return result;
};
const findActiveTab = (tabs: Record<string, ITab>): string => {
  const activeTab = Object.entries(tabs).filter((item) => item[1].IsActive);
  return activeTab[0][0];
};

export default defineComponent({
  name: "HomeTab",
  components: {
    HomeTabItem,
  },
  props: {
    themeProperties: {
      type: Array as PropType<Array<IThemePropertiesFromApi>>,
      required: true,
    },
  },
  setup(props) {
    const authenticated = computed(() => store.state.auth);
    const router = useRouter();
    const { getAssetImage } = commonHelper;
    const tabs = ref<Record<string, ITab>>(renderTabs(props.themeProperties));
    const appDownloadSelected = ref(false);
    const onTabClick = (key: string) => {
      if (!appDownloadSelected.value) {
        tabs.value[findActiveTab(tabs.value)].IsActive = false;
      }
      appDownloadSelected.value = false;
      tabs.value[key].IsActive = true;
    };
    const onAppDownload = () => {
      tabs.value[findActiveTab(tabs.value)].IsActive = false;
      appDownloadSelected.value = true;
    };
    interface HandleItemClick {
      isGameTab: boolean;
      game: GameBsiForLFM1;
    }
    const isCockfightWhitelist = computed(() => store.state.isCockfightWhitelist);
    const tabsForDisplay = computed(() => {
      let stateGames = gameStore.state.games.filter((game) => game.GameType.toLocaleLowerCase() !== 'unknown');
      if (!isCockfightWhitelist.value) stateGames = stateGames.filter((game) => game.GameProviderId !== 46);
            return addGameToTabs(tabs.value, stateGames)
    });
    const handleItemClick = ({ isGameTab, game }: HandleItemClick) => {
      if (!authenticated.value && !isGameTab) {
        router.push("/login");
        return;
      }
      if (!isGameTab) {
        if (game.GameId === 73) {
          handleGameEntryOpenWindow(
            game,
            375,
            667,
            EnumEntranceLocation.GameLobby
          );
        }
        handleGameEntryOpenWindow(
          game,
          850,
          850,
          EnumEntranceLocation.GameLobby
        );
        return;
      }
      if (game.IsProvider) {
        router.push(`/games/${game.GameProviderName}`);
      }
      if (game.IsGameType) {
        router.push(`/games/${game.GameType}__n__gt`);
      }
      if (game.GameType === "Favorite") {
        router.push(`/games/${game.GameType}__n__gt`);
      }
    };
    const { $t } = useNuxtApp();
    const getTheRightGameName = ({ isGameTab, game }: HandleItemClick) => {
      // hard code check for motivation game provider
      if (game.GameProviderId === 1073) {
        return game.GameProviderDisplayName;
      }
      if (!isGameTab) {
        return game.GameName;
      }

      if (game.IsProvider) {
        return game.GameProviderDisplayName;
      } else {
        const translateGameType = $t(String(game.GameType).toLowerCase().replaceAll(' ', '').replaceAll('(', '').replaceAll(')', ''))
       return translateGameType;
      }
    };
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const sportIcon = computed(
      () =>
        `url(${
          themePropertyHelper.getSingleThemeProperty(
            themeProperties.value,
            "index_blog_2"
          ).ImagePath
        }`
    );
    const casinoIcon = computed(
      () =>
        `url(${
          themePropertyHelper.getSingleThemeProperty(
            themeProperties.value,
            "index_blog_4"
          ).ImagePath
        }`
    );
    const virtualIcon = computed(
      () =>
        `url(${
          themePropertyHelper.getSingleThemeProperty(
            themeProperties.value,
            "index_blog_3"
          ).ImagePath
        }`
    );
    const cockfigtingIcon = computed(
      () =>
        `url(${
          themePropertyHelper.getSingleThemeProperty(
            themeProperties.value,
            "index_blog_6"
          ).ImagePath
        }`
    );
    const gameCategoryIcon = computed(
      () =>
        `url(${
          themePropertyHelper.getSingleThemeProperty(
            themeProperties.value,
            "index_blog_5"
          ).ImagePath
        }`
    );
    const lotteryIcon = computed(
      () =>
        `url(${
          themePropertyHelper.getSingleThemeProperty(
            themeProperties.value,
            "index_blog_7"
          ).ImagePath
        }`
    );
    const pokerIcon = computed(
      () =>
        `url(${
          themePropertyHelper.getSingleThemeProperty(
            themeProperties.value,
            "index_blog_8"
          ).ImagePath
        }`
    );
    const appIcon = computed(
      () =>
        `url(${getAssetImage(
          "assets/theme/light_flexible_1/mobile/images/app-icon.png"
        )})`
    );
    const activeSportIcon = computed(() => {
      const sport = themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "index_blog_2_active"
      );
      if (sport.IsHidden) {
        return sportIcon.value;
      }
      return `url(${sport.ImagePath}}`;
    });
    const activeCasinoIcon = computed(() => {
      const casino = themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "index_blog_3_active"
      );
      if (casino.IsHidden) {
        return casinoIcon.value;
      }
      return `url(${casino.ImagePath})`;
    });
    const activeVirtualIcon = computed(() => {
      const virtual = themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "index_blog_4_active"
      );
      if (virtual.IsHidden) {
        return virtualIcon.value;
      }
      return `url(${virtual.ImagePath})`;
    });
    const activeCockfigtingIcon = computed(() => {
      const cockFight = themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "index_blog_6_active"
      );
      if (cockFight.IsHidden) {
        return cockfigtingIcon.value;
      }
      return `url(${cockFight.ImagePath})`;
    });
    const activeGameCategoryIcon = computed(() => {
      const game = themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "index_blog_5_active"
      );
      if (game.IsHidden) {
        return gameCategoryIcon.value;
      }
      return `url(${game.ImagePath})`;
    });
    const activeLotteryIcon = computed(() => {
      const lottery = themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "index_blog_7_active"
      );
      if (lottery.IsHidden) {
        return lotteryIcon.value;
      }
      return `url(${lottery.ImagePath})`;
    });
    const activePokerIcon = computed(() => {
      const poker = themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "index_blog_8_active"
      );
      if (poker.IsHidden) {
        return pokerIcon.value;
      }
      return `url(${poker.ImagePath})`;
    });
    const activeAppIcon = computed(
      () =>
        `url(${getAssetImage(
          "assets/theme/light_flexible_1/mobile/images/app-icon-active.png"
        )})`
    );
    const appBackground = computed(() =>
      getAssetImage(
        "assets/theme/light_flexible_1/mobile/images/entry/app/background.png"
      )
    );
    const { appDownload, appUrl, isAppDownloadEnabled, appDownloadURL } =
      useHeaderComponent();
    const route = useRoute();
    onMounted(() => {
      const selectedTabFromUrl = route.query.tab;
      const allTabs = Object.keys(tabs.value);
      if (!selectedTabFromUrl && !allTabs.includes(String(selectedTabFromUrl)))
        return;
      onTabClick(String(selectedTabFromUrl));
    });
    return {
      tabsForDisplay,
      authenticated,
      onTabClick,
      handleGameEntryOpenWindow,
      handleItemClick,
      getTheRightGameName,
      sportIcon,
      casinoIcon,
      virtualIcon,
      cockfigtingIcon,
      gameCategoryIcon,
      activeSportIcon,
      activeCasinoIcon,
      activeVirtualIcon,
      activeCockfigtingIcon,
      activeGameCategoryIcon,
      pokerIcon,
      activePokerIcon,
      lotteryIcon,
      activeLotteryIcon,
      appIcon,
      activeAppIcon,
      appDownloadSelected,
      onAppDownload,
      appBackground,
      appDownload,
      appUrl,
      isAppDownloadEnabled,
      appDownloadURL,
    };
  },
});
</script>
<style lang="scss">
.tab-shadow {
  box-shadow: 0vw 0.5vw 3vw rgba(65, 70, 92, 0.2);
}
.vertical-menu {
  .tab {
    width: 14vw;
    height: 14vw;
    border: 0.2vw solid #c6d0ff;
    background-size: cover;
    box-shadow: 0vw 0.5vw 3vw rgba(65, 70, 92, 0.3);
    color: #9aa4c2;
    .vertical-tab-icon {
      width: 5vw;
      height: 5vw;
    }
    #sportIcon {
      background-image: v-bind("sportIcon");
      background-size: cover;
    }
    #casinoIcon {
      background-image: v-bind("casinoIcon");
      background-size: cover;
    }
    #vSportIcon {
      background-image: v-bind("virtualIcon");
      background-size: cover;
    }
    #cockFightingIcon {
      background-image: v-bind("cockfigtingIcon");
      background-size: cover;
    }
    #gameIcon {
      background-image: v-bind("gameCategoryIcon");
      background-size: cover;
    }
    #lotteryIcon {
      background-image: v-bind("lotteryIcon");
      background-size: cover;
    }
    #pokerIcon {
      background-image: v-bind("pokerIcon");
      background-size: cover;
    }
    #appIcon {
      background-image: v-bind("appIcon");
      background-size: cover;
    }
  }
  .tab.active {
    background: var(--primary-button) !important;
    .vertical-tab-icon {
      width: 6vw;
      height: 6vw;
    }
    span {
      color: var(--active-text-color2);
    }

    #sportIcon {
      background-image: v-bind("activeSportIcon") !important;
    }
    #vSportIcon {
      background-image: v-bind("activeCasinoIcon") !important;
    }
    #casinoIcon {
      background-image: v-bind("activeVirtualIcon") !important;
    }
    #cockFightingIcon {
      background-image: v-bind("activeCockfigtingIcon") !important;
    }
    #gameIcon {
      background-image: v-bind("activeGameCategoryIcon") !important;
    }
    #lotteryIcon {
      background-image: v-bind("activeLotteryIcon") !important;
    }
    #pokerIcon {
      background-image: v-bind("activePokerIcon") !important;
    }
    #appIcon {
      background-image: v-bind("activeAppIcon") !important;
    }
  }
  .active {
    border: none !important;
    box-shadow: 0vw 0.5vw 3vw rgba(17, 0, 255, 0.3) !important;
  }
  .active .ball-icon {
    background-position-y: -37% !important;
  }
}
.games-tab {
  transition: 1s ease-in;
  animation-duration: 1s;
  animation-name: pullUpAnimation;
}

@keyframes pullUpAnimation {
  from {
    top: 100px;
  }
  to {
    top: 0;
  }
}
.fadeInUp {
  animation: fadeInUp 0.6s ease backwards;
}
@keyframes fadeInUp {
  0% {
    transform: translate(0, 500px);
    opacity: 0;
  }
  100% {
    transform: translate(0, 0);
    opacity: 1;
  }
}
</style>
